<?php

class p_usertab_uc extends cmsPlugin {
	
	private $inUser;

    public function __construct(){
		
		global $_LANG;

		$this->info = array(
			'plugin'      => 'p_usertab_uc',
			'title'       => 'Записи в каталоге',
			'description' => 'Выводит в профиле пользователя его записи в универсальном каталоге',
			'author'      => '<a target="_blank" href="http://www.instantcms.ru/users/grusin">Олег Васильевич</a>',
			'version'     => '2.1',
			'tab'         => $_LANG['PLU_TAB_TITLE']
		);
		
		$this->config = array(
			'limit'       => 12, // Лимит
			'only_user'   => 0, // Только авторизованным
			'my_products' => 0, // Только свой профиль
			'only_group'  => array(2), // Только у выбранных групп
			'show_tab'    => 0, // Показывать или нет пустую вкладку
			'link_to'     => 1  // Показывать или нет ссылку на каталог
		);
		
		$this->events[] = 'USER_PROFILE';
		$this->inUser   = cmsUser::getInstance();
		
		parent::__construct();
		
    }

    public function execute($event='', $user=array()){
	    
		global $_LANG;

		$message  = false;
		$cats     = array();
		$is_user  = $this->inUser->id > 0;
		$is_admin = $this->inUser->is_admin;
		$is_autor = $this->inUser->id == $user['id'] || $is_admin;

		// Не автору показываем товары только выбранных групп и только в своем профиле если включено
		if(!$is_autor && ($this->config['my_products'] || (!is_array($this->config['only_group']) || !in_array($user['group_id'], $this->config['only_group'])))){
			return false;
		
		// Если включено, показываем вкладку только авторизованным
		} elseif($this->config['only_user'] && !$is_user){
			$message = $_LANG['PLU_ACCESS_DENIED'];
		
		// Если дошли сюда значит пора делать выборку из базы
		} else {
			$sql = "SELECT id,
						   title,
						   published,
						   imageurl,
						   price
					FROM cms_uc_items
					WHERE user_id = '{$user['id']}'
					ORDER BY published DESC
					LIMIT {$this->config['limit']}";
			$res = $this->inDB->query($sql);
			
			// Вернулся пустой результат
			if(!$this->inDB->num_rows($res)){
				
				// Показывать/не показывать вкладку если записей нет
				if($this->config['show_tab'] && !$is_autor){
					return false;
				} else {
					$message = $this->inUser->id == $user['id'] ? $_LANG['PLU_NO_ENTRIES_MY'] : $_LANG['PLU_NO_ENTRIES'];
				}

			// Все. Остается только заполнить массив данных
			} else {
				while($cat = $this->inDB->fetch_assoc($res)){
					$cat['url'] = '/catalog/item'.$cat['id'].'.html';
					$cats[] = $cat;
				}
			}
		}
		
		// Отрисовка шаблона...
		$this->inPage->addHeadCSS('templates/'.TEMPLATE.'/css/p_usertab_uc.css');
		ob_start();
        cmsPage::initTemplate('plugins', 'p_usertab_uc')->
		assign('cats', $cats)->
		assign('message', $message)->
		assign('show_link', $this->config['link_to'])->
		display('p_usertab_uc.tpl');
        return ob_get_clean();

	}
}